<?php

namespace Treewec\Admin;

/**
 * Test class for FileCopyForm.
 * Generated by PHPUnit on 2012-06-25 at 13:15:14.
 * @group admin_fileform
 */
class FileCopyFormTest extends \PHPUnit_Framework_TestCase {

    private $formObject;

    protected function setUp() {
        $_POST['submit'] = 'submit';
    }

    public function testSuccessCopy() {
        $newFolders = array('existing/', 'existing-žeš/');
        foreach ($newFolders as $newFolder) {
            $newPath = $this->getPath($newFolder . 'test', true);
            $this->setFormAndProcess(TEMP_FILEDIR . 'test.php', $newFolder);
            parent::assertTrue($this->formObject->isValid());
            parent::assertTrue(file_exists($newPath));
            unlink($newPath);
        }
    }

    public function testInvalidNewDirectory() {
        $invalid = array(
            new \Exception(), // it must be string
            '** ? dsa ///', // without invalid characters
            'unexisting', // directory must exists in RootDirectory
            'existing-žeš', // file cannot already exists in folder
        );
        foreach ($invalid as $invalidPath) {
            $this->setFormAndProcess(TEMP_FILEDIR . 'index.php', $invalidPath);
            parent::assertFalse($this->formObject->isValid());
        }
    }

    public function testInvalidPath() {
        $invalid = array(
            new \Exception(), // it must be string
            '** ? dsa ///', // without invalid characters
            TREEWEC_VIEW_DIR, // main publication folder cannot be moved
            TREEWEC_VIEW_DIR . 'teams/' // folder cannot be copied
        );
        foreach ($invalid as $invalidPath) {
            $this->setFormAndProcess($invalidPath, 'existing/');
            parent::assertFalse($this->formObject->isValid());
        }
    }

    private function setFormAndProcess($filePath, $newFolder) {
        $this->formObject = new FileCopyForm('submit', true);
        $this->formObject->setSuccessAction(FormSuccessAction::NOTHING);
        $this->formObject->setRootDirectory(TEMP_FILEDIR);
        $_POST['new_folder'] = $newFolder;
        $this->formObject->setFilePath($filePath);
        $this->formObject->process();
    }

    private function getPath($name, $isFile) {
        $extension = $isFile ? '.php' : '';
        return TEMP_FILEDIR . \Treewec\FileSystem\Path::toFileSystem($name) . $extension;
    }

}

?>